#pragma once
#include <cctype>
#include <typeinfo>
#include <msclr/marshal_cppstd.h>

namespace USBExample {
    using namespace System;
    using namespace System::ComponentModel;
    using namespace System::Collections;
    using namespace System::Windows::Forms;
    using namespace System::Data;
    using namespace System::Drawing;
    using namespace std;
    using namespace msclr::interop;
    using namespace FUTEK::Devices;

    public ref class MyForm : public System::Windows::Forms::Form
    {
    public:
        MyForm(void)
        {
            InitializeComponent();
            SerialNumber = nullptr;
            ModelNumber = nullptr;
            oFUTEKDeviceRepoDLL = nullptr;
            oFUTEKDeviceDLL = nullptr;
            oFUTEKDeviceUSB225DLL = nullptr;
        }

    protected:
        ~MyForm()
        {
            if (SerialNumber != nullptr)
            {
                delete SerialNumber;
            }
            if (ModelNumber != nullptr)
            {
                delete ModelNumber;
            }
            if (components != nullptr)
            {
                delete components;
            }
        }

    protected:
    internal: System::Windows::Forms::Button^ ButtonStop;
    internal: System::Windows::Forms::Button^ ButtonStart;
    internal: System::Windows::Forms::TextBox^ TextBoxUnits;
    internal: System::Windows::Forms::TextBox^ TextBoxCalculatedReading;
    internal: System::Windows::Forms::TextBox^ TextBoxSerialNumber;
    internal: System::Windows::Forms::Label^ LabelUnits;
    internal: System::Windows::Forms::Label^ LabelCalculatedReading;
    internal: System::Windows::Forms::Label^ LabelSerialNumber;
    internal: System::Windows::Forms::TextBox^ ModelNumberTextBox;
    internal: System::Windows::Forms::Label^ LabelModelNumber;
    private: System::ComponentModel::IContainer^ components;

    private:
        FUTEK::Devices::DeviceRepository^ oFUTEKDeviceRepoDLL;
        FUTEK::Devices::Device^ oFUTEKDeviceDLL;
        FUTEK::Devices::DeviceUSB225^ oFUTEKDeviceUSB225DLL;
        String^ SerialNumber;
        String^ ModelNumber;

#pragma region Windows Form Designer generated code
        void InitializeComponent(void)
        {
            this->ButtonStop = (gcnew System::Windows::Forms::Button());
            this->ButtonStart = (gcnew System::Windows::Forms::Button());
            this->TextBoxUnits = (gcnew System::Windows::Forms::TextBox());
            this->TextBoxCalculatedReading = (gcnew System::Windows::Forms::TextBox());
            this->TextBoxSerialNumber = (gcnew System::Windows::Forms::TextBox());
            this->LabelUnits = (gcnew System::Windows::Forms::Label());
            this->LabelCalculatedReading = (gcnew System::Windows::Forms::Label());
            this->LabelSerialNumber = (gcnew System::Windows::Forms::Label());
            this->ModelNumberTextBox = (gcnew System::Windows::Forms::TextBox());
            this->LabelModelNumber = (gcnew System::Windows::Forms::Label());
            this->SuspendLayout();
            // 
            // ButtonStop
            // 
            this->ButtonStop->Location = System::Drawing::Point(595, 28);
            this->ButtonStop->Name = L"ButtonStop";
            this->ButtonStop->Size = System::Drawing::Size(72, 23);
            this->ButtonStop->TabIndex = 44;
            this->ButtonStop->Text = L"Disconnect";
            this->ButtonStop->UseVisualStyleBackColor = true;
            this->ButtonStop->Click += gcnew System::EventHandler(this, &MyForm::ButtonStop_Click);
            // 
            // ButtonStart
            // 
            this->ButtonStart->Location = System::Drawing::Point(533, 28);
            this->ButtonStart->Name = L"ButtonStart";
            this->ButtonStart->Size = System::Drawing::Size(58, 23);
            this->ButtonStart->TabIndex = 43;
            this->ButtonStart->Text = L"Get Data";
            this->ButtonStart->UseVisualStyleBackColor = true;
            this->ButtonStart->Click += gcnew System::EventHandler(this, &MyForm::ButtonStart_Click);
            // 
            // TextBoxUnits
            // 
            this->TextBoxUnits->BackColor = System::Drawing::SystemColors::ButtonShadow;
            this->TextBoxUnits->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point,
                static_cast<System::Byte>(0)));
            this->TextBoxUnits->Location = System::Drawing::Point(407, 29);
            this->TextBoxUnits->Name = L"TextBoxUnits";
            this->TextBoxUnits->ReadOnly = true;
            this->TextBoxUnits->Size = System::Drawing::Size(120, 22);
            this->TextBoxUnits->TabIndex = 42;
            this->TextBoxUnits->Text = L"Units";
            this->TextBoxUnits->TextAlign = System::Windows::Forms::HorizontalAlignment::Center;
            // 
            // TextBoxCalculatedReading
            // 
            this->TextBoxCalculatedReading->BackColor = System::Drawing::SystemColors::ButtonShadow;
            this->TextBoxCalculatedReading->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Bold,
                System::Drawing::GraphicsUnit::Point, static_cast<System::Byte>(0)));
            this->TextBoxCalculatedReading->Location = System::Drawing::Point(243, 29);
            this->TextBoxCalculatedReading->Name = L"TextBoxCalculatedReading";
            this->TextBoxCalculatedReading->ReadOnly = true;
            this->TextBoxCalculatedReading->Size = System::Drawing::Size(160, 22);
            this->TextBoxCalculatedReading->TabIndex = 41;
            this->TextBoxCalculatedReading->Text = L"000.000";
            this->TextBoxCalculatedReading->TextAlign = System::Windows::Forms::HorizontalAlignment::Center;
            // 
            // TextBoxSerialNumber
            // 
            this->TextBoxSerialNumber->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Bold,
                System::Drawing::GraphicsUnit::Point, static_cast<System::Byte>(0)));
            this->TextBoxSerialNumber->Location = System::Drawing::Point(124, 29);
            this->TextBoxSerialNumber->Name = L"TextBoxSerialNumber";
            this->TextBoxSerialNumber->ReadOnly = true;
            this->TextBoxSerialNumber->Size = System::Drawing::Size(106, 22);
            this->TextBoxSerialNumber->TabIndex = 40;
            this->TextBoxSerialNumber->TextAlign = System::Windows::Forms::HorizontalAlignment::Center;
            // 
            // LabelUnits
            // 
            this->LabelUnits->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point,
                static_cast<System::Byte>(0)));
            this->LabelUnits->Location = System::Drawing::Point(407, 10);
            this->LabelUnits->Name = L"LabelUnits";
            this->LabelUnits->Size = System::Drawing::Size(120, 16);
            this->LabelUnits->TabIndex = 39;
            this->LabelUnits->Text = L"Units";
            this->LabelUnits->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
            // 
            // LabelCalculatedReading
            // 
            this->LabelCalculatedReading->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Bold,
                System::Drawing::GraphicsUnit::Point, static_cast<System::Byte>(0)));
            this->LabelCalculatedReading->Location = System::Drawing::Point(243, 10);
            this->LabelCalculatedReading->Name = L"LabelCalculatedReading";
            this->LabelCalculatedReading->Size = System::Drawing::Size(160, 16);
            this->LabelCalculatedReading->TabIndex = 38;
            this->LabelCalculatedReading->Text = L"Sensor Reading";
            this->LabelCalculatedReading->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
            // 
            // LabelSerialNumber
            // 
            this->LabelSerialNumber->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point,
                static_cast<System::Byte>(0)));
            this->LabelSerialNumber->Location = System::Drawing::Point(124, 10);
            this->LabelSerialNumber->Name = L"LabelSerialNumber";
            this->LabelSerialNumber->Size = System::Drawing::Size(106, 16);
            this->LabelSerialNumber->TabIndex = 37;
            this->LabelSerialNumber->Text = L"Serial Number";
            this->LabelSerialNumber->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
            // 
            // ModelNumberTextBox
            // 
            this->ModelNumberTextBox->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point,
                static_cast<System::Byte>(0)));
            this->ModelNumberTextBox->Location = System::Drawing::Point(12, 29);
            this->ModelNumberTextBox->Name = L"ModelNumberTextBox";
            this->ModelNumberTextBox->ReadOnly = true;
            this->ModelNumberTextBox->Size = System::Drawing::Size(100, 22);
            this->ModelNumberTextBox->TabIndex = 36;
            this->ModelNumberTextBox->TextAlign = System::Windows::Forms::HorizontalAlignment::Center;
            // 
            // LabelModelNumber
            // 
            this->LabelModelNumber->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point,
                static_cast<System::Byte>(0)));
            this->LabelModelNumber->Location = System::Drawing::Point(12, 10);
            this->LabelModelNumber->Name = L"LabelModelNumber";
            this->LabelModelNumber->Size = System::Drawing::Size(100, 16);
            this->LabelModelNumber->TabIndex = 35;
            this->LabelModelNumber->Text = L"Model Number";
            this->LabelModelNumber->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
            // 
            // MyForm
            // 
            this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
            this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
            this->ClientSize = System::Drawing::Size(679, 78);
            this->Controls->Add(this->ButtonStop);
            this->Controls->Add(this->ButtonStart);
            this->Controls->Add(this->TextBoxUnits);
            this->Controls->Add(this->TextBoxCalculatedReading);
            this->Controls->Add(this->TextBoxSerialNumber);
            this->Controls->Add(this->LabelUnits);
            this->Controls->Add(this->LabelCalculatedReading);
            this->Controls->Add(this->LabelSerialNumber);
            this->Controls->Add(this->ModelNumberTextBox);
            this->Controls->Add(this->LabelModelNumber);
            this->Name = L"MyForm";
            this->Text = L"USB225 Visual C++ Read Sensor Data Example";
            this->Load += gcnew System::EventHandler(this, &MyForm::MyForm_Load);
            this->ResumeLayout(false);
            this->PerformLayout();
        }
#pragma endregion

    private:
        System::Void MyForm_Load(System::Object^ sender, System::EventArgs^ e)
        {
            try
            {
                oFUTEKDeviceRepoDLL = gcnew FUTEK::Devices::DeviceRepository();
                auto devices = oFUTEKDeviceRepoDLL->DetectDevices();
                oFUTEKDeviceDLL = devices[0];

                if (oFUTEKDeviceRepoDLL->DeviceCount > 0)
                {
                    ButtonStart->Enabled = true;
                    ButtonStop->Enabled = false;
                }
                else
                {
                    MessageBox::Show("No devices found.");
                }
            }
            catch (System::Exception^ ex)
            {
                MessageBox::Show("Exception: " + ex->Message);
            }
        }

        System::Void ButtonStart_Click(System::Object^ sender, System::EventArgs^ e)
        {
            if (oFUTEKDeviceDLL != nullptr)
            {
                ModelNumber = oFUTEKDeviceDLL->GetModelNumber();
                SerialNumber = oFUTEKDeviceDLL->GetInstrumentSerialNumber();
                ModelNumberTextBox->Text = ModelNumber;
                TextBoxSerialNumber->Text = SerialNumber;
                oFUTEKDeviceUSB225DLL = (DeviceUSB225^)oFUTEKDeviceDLL;

                TextBoxCalculatedReading->Text = System::String::Format("{0:F3}", oFUTEKDeviceUSB225DLL->GetChannelXReading(0));
                TextBoxUnits->Text = oFUTEKDeviceUSB225DLL->GetChannelXUnitOfMeasure(0).ToString();
                ButtonStop->Enabled = true;
            }
            else {
                try
                {
                    oFUTEKDeviceRepoDLL = gcnew FUTEK::Devices::DeviceRepository();
                    auto devices = oFUTEKDeviceRepoDLL->DetectDevices();
                    oFUTEKDeviceDLL = devices[0];

                    if (oFUTEKDeviceRepoDLL->DeviceCount > 0)
                    {
                        ModelNumber = oFUTEKDeviceDLL->GetModelNumber();
                        SerialNumber = oFUTEKDeviceDLL->GetInstrumentSerialNumber();
                        ModelNumberTextBox->Text = ModelNumber;
                        TextBoxSerialNumber->Text = SerialNumber;
                        oFUTEKDeviceUSB225DLL = (DeviceUSB225^)oFUTEKDeviceDLL;
                        TextBoxCalculatedReading->Text = System::String::Format("{0:F3}", oFUTEKDeviceUSB225DLL->GetChannelXReading(0));
                        TextBoxUnits->Text = oFUTEKDeviceUSB225DLL->GetChannelXUnitOfMeasure(0).ToString();

                        ButtonStart->Enabled = true;
                        ButtonStop->Enabled = true;
                    }
                    else
                    {
                        MessageBox::Show("No devices found.");
                    }
                }
                catch (System::Exception^ ex)
                {
                    MessageBox::Show("Exception: " + ex->Message);
                }
            }
        }

        System::Void ButtonStop_Click(System::Object^ sender, System::EventArgs^ e)
        {
            oFUTEKDeviceRepoDLL->DisconnectAllDevices();

            delete oFUTEKDeviceRepoDLL;
            oFUTEKDeviceRepoDLL = nullptr;
            delete oFUTEKDeviceDLL;
            oFUTEKDeviceDLL = nullptr;
            delete oFUTEKDeviceUSB225DLL;
            oFUTEKDeviceUSB225DLL = nullptr;

            TextBoxCalculatedReading->Text = "000.000";
            TextBoxUnits->Text = "Units";
            ModelNumberTextBox->Text = "";
            TextBoxSerialNumber->Text = "";

            ButtonStop->Enabled = false;
        }
    };
}